Imports System.ComponentModel
Imports System

Public Class XPropDescriptor
    Inherits PropertyDescriptor

    Private theProp As XProp

    Public Sub New(ByVal prop As XProp, ByVal attrs() As Attribute)
        MyBase.New(prop.Name, attrs)
        theProp = prop
    End Sub

    Public Overrides Function CanResetValue(ByVal component As Object) As Boolean
        Return False
    End Function

    Public Overrides ReadOnly Property ComponentType() As System.Type
        Get
            Return Me.GetType
        End Get
    End Property

    Public Overrides Function GetValue(ByVal component As Object) As Object
        Return theProp.Value
    End Function

    Public Overrides ReadOnly Property IsReadOnly() As Boolean
        Get
            Return False
        End Get
    End Property

    Public Overrides ReadOnly Property PropertyType() As System.Type
        Get
            Return theProp.Value.GetType()
        End Get
    End Property

    Public Overrides Sub ResetValue(ByVal component As Object)
        ' Do Nothing
    End Sub

    Public Overrides Sub SetValue(ByVal component As Object, ByVal value As Object)
        theProp.Value = value
    End Sub

    Public Overrides Function ShouldSerializeValue(ByVal component As Object) As Boolean
        Return False
    End Function

End Class
