Imports System
Imports System.ComponentModel
Imports System.Text

Public Class XProps
    Inherits List(Of XProp)
    Implements ICustomTypeDescriptor

#Region "ICustomTypeDescriptor Implementation"
    Public Function GetAttributes() As AttributeCollection _
    Implements ICustomTypeDescriptor.GetAttributes
        Return TypeDescriptor.GetAttributes(Me, True)
    End Function

    Public Function GetClassName() As String _
    Implements ICustomTypeDescriptor.GetClassName
        Return TypeDescriptor.GetClassName(Me, True)
    End Function

    Public Function GetComponentName() As String _
    Implements ICustomTypeDescriptor.GetComponentName
        Return TypeDescriptor.GetClassName(Me, True)
    End Function

    Public Function GetConverter() As TypeConverter _
    Implements ICustomTypeDescriptor.GetConverter
        Return TypeDescriptor.GetConverter(Me, True)
    End Function

    Public Function GetDefaultEvent() As EventDescriptor _
    Implements ICustomTypeDescriptor.GetDefaultEvent
        Return TypeDescriptor.GetDefaultEvent(Me, True)
    End Function

    Public Function GetDefaultProperty() As PropertyDescriptor _
    Implements ICustomTypeDescriptor.GetDefaultProperty
        Return TypeDescriptor.GetDefaultProperty(Me, True)
    End Function

    Public Function GetEditor(ByVal editorBaseType As System.Type) As Object _
    Implements ICustomTypeDescriptor.GetEditor
        Return TypeDescriptor.GetEditor(Me, editorBaseType, True)
    End Function

    Public Function GetEvents() As EventDescriptorCollection _
    Implements ICustomTypeDescriptor.GetEvents
        Return TypeDescriptor.GetEvents(Me, True)
    End Function

    Public Function GetEvents(ByVal attributes() As System.Attribute) _
    As EventDescriptorCollection _
    Implements ICustomTypeDescriptor.GetEvents
        Return TypeDescriptor.GetEvents(Me, attributes, True)
    End Function

    Public Function GetProperties() As PropertyDescriptorCollection _
    Implements ICustomTypeDescriptor.GetProperties
        Return TypeDescriptor.GetProperties(Me, True)
    End Function

    Public Function GetProperties(ByVal attributes() As System.Attribute) _
    As PropertyDescriptorCollection _
    Implements ICustomTypeDescriptor.GetProperties

        Dim props(Count) As PropertyDescriptor
        Dim i As Int32
        For i = 0 To Count - 1
            props(i) = New XPropDescriptor(Item(i), attributes)
        Next
        Return New PropertyDescriptorCollection(props)
    End Function

    Public Function GetPropertyOwner(ByVal pd As PropertyDescriptor) _
    As Object _
    Implements ICustomTypeDescriptor.GetPropertyOwner
        Return Me
    End Function
#End Region

    Public Overrides Function ToString() As String
        Dim sbld As StringBuilder = New StringBuilder
        Dim i As Int32
        For i = 0 To Count - 1
            sbld.Append("[" & i & "] " & Item(i).ToString & vbNewLine)
        Next
        Return sbld.ToString
    End Function
End Class
